MODULE mod_mpg
IMPLICIT NONE
PUBLIC
TYPE:: mpeg_parameters
 INTEGER :: mtype
 INTEGER :: layer
 INTEGER :: ibit_rate
 INTEGER :: isample_rate
 INTEGER :: ipadding
 INTEGER :: icrc
 INTEGER :: iextension
 INTEGER :: mode
 INTEGER :: mode_extension
 INTEGER :: icopyright
 INTEGER :: ioriginal
 INTEGER :: iemphasis
END TYPE mpeg_parameters
!MPEG1 / audio
INTEGER, PARAMETER :: mpeg_frame_size(3)      = (/1152, 1152, 384/)
INTEGER, PARAMETER :: mpeg_sample_rates(0:3)  = (/44100, 48000, 32000, 0/)
INTEGER, PARAMETER :: mpeg_bit_rates(0:14, 3) = &
  RESHAPE( (/ 0, 32, 40, 48,  56,  64,  80,  96, 112, 128, 160, 192, 224, 256, 320,    &
              0, 32, 48, 56,  64,  80,  96, 112, 128, 160, 192, 224, 256, 320, 384,    &
              0, 32, 64, 96, 128, 160, 192, 224, 256, 288, 320, 352, 384, 414, 448 /), &
           (/15, 3/) )
CHARACTER (LEN = 8) :: mpeg_mode_names(4)      = (/'stereo  ', 'j-stereo', 'dual-ch ', 'mono    '/)
CHARACTER (LEN = 3) :: mpeg_layer_names(3)     = (/'III', 'II ', 'I  '/)
CHARACTER (LEN = 7) :: mpeg_version_names(0:3) = (/'MPEG2.5', '       ', 'MPEG-II', 'MPEG-I '/)
CHARACTER (LEN = 7) :: mpeg_demp_names(4)      = (/'none   ', '50/15us', '       ', 'CITT   '/)
!-------------------------------------------------------------------------------------------
!MPEG1 / Layer3
TYPE :: side_info_sub
 INTEGER :: ipart2_3_length        ! 12 bits
 INTEGER :: ibig_values            !  9 bits
 INTEGER :: iglobal_gain           !  8 bits
 INTEGER :: iscalefac_compress     !  4 bits
 INTEGER :: iwindow_switching_flag !  1 bit
! if short block 
 INTEGER ::  iblock_type           !  2 bits
 INTEGER ::  mixied_block_flag     !  1 bit
 INTEGER ::  itable_select(3)      !  5 bits
 INTEGER ::  isubblock_gain(3)     !  3 bits
! if long block
!INTEGER ::  itable_select(3, 2, 2) 
 INTEGER ::  iregion0_count        !  4 bits
 INTEGER ::  iregion1_count        !  3 bits
! 
 INTEGER :: ipreflag               !  1 bit
 INTEGER :: iscalefac_scale        !  1 bit
 INTEGER :: icount1table_select    !  1 bit
!........
 INTEGER :: icount1  ! local use (not real side_info)
END TYPE side_info_sub
!
TYPE :: side_info_                 !136 bits for mono / 256 bits for stereo
 INTEGER :: main_data_begin        !  9 bits
 INTEGER :: iprivate_bits          !  5 bits for mono /   3 bits for stereo
 INTEGER :: iscfsi(4, 2)           !  1 bit 
 TYPE (side_info_sub) :: sub(2, 2)
END TYPE side_info_
!
INTEGER, PARAMETER :: len_scale_compress(0:15, 2) = &
         RESHAPE( (/ 0, 0, 0, 0, 3, 1, 1, 1, 2, 2, 2, 3, 3, 3, 4, 4, &
                     0, 1, 2, 3, 0, 1, 2, 3, 1, 2, 3, 1, 2, 3, 2, 3  /), (/16, 2/) )
INTEGER, SAVE :: iscalefactorband_l(0:20, 3), iscalefactorband_s(0:11, 3) ! PUBLIC
!-------------------------------------------------------------------------------------------
! global parameter
LOGICAL, SAVE :: qms_stereo = .TRUE., q_long = .TRUE., q_alias = .TRUE., q_mask = .TRUE.
LOGICAL, SAVE :: q_sm = .TRUE., q_vbr = .FALSE., q_rio500 = .FALSE., q_info = .TRUE., q_cheat = .TRUE. 
INTEGER, SAVE :: icut = 32, mblock_type_param = 20 ! default short block! long = 0, short = 20, mixed = 21
INTEGER, SAVE :: n_switch_max = 22 ! for 44.1kHz see Psycho
INTEGER, SAVE :: iscalefac_scale, iscalefac_scale0 = 0, nscf = 0, nscf_l = 0, nscf_s = 0, n_sc_l = 0, n_sc_s = 0
REAL (KIND = 8), SAVE :: tot_sc_l(0:20) = 0.0d0, tot_sc_s(0:11, 3) = 0.0d0
!debug parameters
integer, save :: m1 = 0, m3 = 0, mix = 0, long = 0, nshort = 0, ntable(0:31) = 0, ntab_ab(0:1) = 0
integer, save :: ms = 0, ns1 = 0, ns2 = 0, nn1 = 0, nn2 = 0, nbits(14), n_isc = 0
!system parameters
REAL (KIND = 8), SAVE :: cut_factor = 1.0d0, distortion_max, ath_min = -115.0d0 ! ath_min = 110 ~ 120 ?
REAL (KIND = 8), SAVE :: switch = 2.0d0, xms = 0.50d0, r0 = 0.25d0, r1 = 0.67d0 ! ISO r0 0.33 r1 0.75
REAL (KIND = 8), SAVE :: a_noise = 5.0d-3, p_noise = 0.09d0, pm_factor = 1.0d0
!-------------------------------------------------------------------------------------------
END MODULE mod_mpg
